<?php

    class Skip_To_Step_Action extends Reactor_Action
    {
        protected $tpl = 'skip_to_step.php';
        protected $name = 'Skip to block';
		
		public static $registration = array(
			ACTION_NAME => 'Skip to block',
			ACTION_CATEGORY => 'Nagios Reactor',
			ACTION_DESCRIPTION => 'Skips ahead to a specific block in an event chain.',
			ACTION_AUTHOR => 'Jeremy Yunis, Nagios Enterprises, LLC',
			ACTION_VERSION => '1.0',
			ACTION_DATE => '01/22/2013', //Last version update
			ACTION_AUTHLEVEL => 0,  // 0 - everyone | 1 - Admin only
			ACTION_TYPE => 'core', //core | user. core modules can't be deleted
			ACTION_META => array(),	//Misc information	
		); 
		
        protected $fields = array(
            'step' => array(
                'label' => 'step',
                'validate' => 'trim|required|numeric|min_length[1]|max_length[4]',
            ),
        );

        public function get_label()
        {
            if($params = $this->get_params()) {
                if(array_key_exists('step', $params)) {
                    return sprintf('Skip to event chain block #%d', $params['step']);
                }
            }
            return parent::get_label();
        }
       
        public function run($context)
        {
            $this->set_context($context);
            $params = $this->get_params();
            $this->set_result(0);
            $context['__reactor__']['skip_to'] = $params['step'];
            return $context;
        }
    }
